## wxHtmlCell

Internal data structure. It represents fragments of parsed HTML page, the so-called cell - a word, picture, table, horizontal line and so on. It is used by wxHtmlWindow and wxHtmlWinParser to represent HTML page in memory.

You can divide cells into two groups : visible cells with non-zero width and height and helper cells (usually with zero width and height) that perform special actions such as color or font change.

Derived from

wxObject

Include files

<wx/html/htmlcell.h>

See Also

Cells Overview, wxHtmlContainerCell

Members

wxHtmlCell::wxHtmlCell
wxHtmlCell::AdjustPagebreak
wxHtmlCell::Draw
wxHtmlCell::DrawInvisible
wxHtmlCell::Find
wxHtmlCell::GetDescent
wxHtmlCell::GetHeight
wxHtmlCell::GetId
wxHtmlCell::GetLink
wxHtmlCell::GetNext
wxHtmlCell::GetParent
wxHtmlCell::GetPosX
wxHtmlCell::GetPosY
wxHtmlCell::GetWidth
wxHtmlCell::Layout
wxHtmlCell::OnMouseClick
wxHtmlCell::SetId
wxHtmlCell::SetLink
wxHtmlCell::SetNext
wxHtmlCell::SetParent
wxHtmlCell::SetPos

### wxHtmlCell::wxHtmlCell

wxHtmlCell()

Constructor.

### wxHtmlCell::AdjustPagebreak

virtual bool AdjustPagebreak(int * pagebreak)

This method is used to adjust pagebreak position. The parameter is variable that contains y-coordinate of page break (= horizontal line that should not be crossed by words, images etc.). If this cell cannot be divided into two pieces (each one on another page) then it moves the pagebreak few pixels up.

Returns TRUE if pagebreak was modified, FALSE otherwise

Usage:

    while (container->AdjustPagebreak(&p)) {}

### wxHtmlCell::Draw

virtual void Draw(wxDC& dc, int x, int y, int view_y1, int view_y2)

Renders the cell.

Parameters

dc

Device context to which the cell is to be drawn

x,y

Coordinates of parent's upper left corner (origin). You must add this to m_PosX,m_PosY when passing coordinates to dc's methods Example : `dc -> DrawText("hello", x + m_PosX, y + m_PosY)`

view_y1

y-coord of the first line visible in window. This is used to optimize rendering speed

view_y2

y-coord of the last line visible in window. This is used to optimize rendering speed

### wxHtmlCell::DrawInvisible

virtual void DrawInvisible(wxDC& dc, int x, int y)

This method is called instead of Draw when the cell is certainly out of the screen (and thus invisible). This is not nonsense - some tags (like wxHtmlColourCell or font setter) must be drawn even if they are invisible!

Parameters

dc

Device context to which the cell is to be drawn

x,y

Coordinates of parent's upper left corner. You must add this to m_PosX,m_PosY when passing coordinates to dc's methods Example : `dc -> DrawText("hello", x + m_PosX, y + m_PosY)`

### wxHtmlCell::Find

virtual const wxHtmlCell* Find(int condition, const void* param)

Returns pointer to itself if this cell matches condition (or if any of the cells following in the list matches), NULL otherwise. (In other words if you call top-level container's Find it will return pointer to the first cell that matches the condition)

It is recommended way how to obtain pointer to particular cell or to cell of some type (e.g. wxHtmlAnchorCell reacts on wxHTML_COND_ISANCHOR condition)

Parameters

condition

Unique integer identifier of condition

param

Optional parameters

Defined conditions

wxHTML_COND_ISANCHOR | Finds particular anchor. param is pointer to wxString with name of the anchor.
wxHTML_COND_USER | User-defined conditions start from this number.

### wxHtmlCell::GetDescent

int GetDescent() const

Returns descent value of the cell (m_Descent member). See explanation:

### wxHtmlCell::GetHeight

int GetHeight() const

Returns height of the cell (m_Height member).

### wxHtmlCell::GetId

virtual wxString GetId() const

Returns unique cell identifier if there is any, empty string otherwise.

### wxHtmlCell::GetLink

virtual wxHtmlLinkInfo* GetLink(int x = 0, int y = 0) const

Returns hypertext link if associated with this cell or NULL otherwise. See wxHtmlLinkInfo. (Note: this makes sense only for visible tags).

Parameters

x,y

Coordinates of position where the user pressed mouse button. These coordinates are used e.g. by COLORMAP. Values are relative to the upper left corner of THIS cell (i.e. from 0 to m_Width or m_Height)

### wxHtmlCell::GetNext

wxHtmlCell* GetNext() const

Returns pointer to the next cell in list (see htmlcell.h if you're interested in details).

### wxHtmlCell::GetParent

wxHtmlContainerCell* GetParent() const

Returns pointer to parent container.

### wxHtmlCell::GetPosX

int GetPosX() const

Returns X position within parent (the value is relative to parent's upper left corner). The returned value is meaningful only if parent's Layout was called before!

### wxHtmlCell::GetPosY

int GetPosY() const

Returns Y position within parent (the value is relative to parent's upper left corner). The returned value is meaningful only if parent's Layout was called before!

### wxHtmlCell::GetWidth

int GetWidth() const

Returns width of the cell (m_Width member).

### wxHtmlCell::Layout

virtual void Layout(int w)

This method performs two actions:

1. adjusts the cell's width according to the fact that maximal possible width is w. (this has sense when working with horizontal lines, tables etc.)
2. prepares layout (=fill-in m_PosX, m_PosY (and sometimes m_Height) members) based on actual width w

It must be called before displaying cells structure because m_PosX and m_PosY are undefined (or invalid) before calling Layout.

### wxHtmlCell::OnMouseClick

virtual void OnMouseClick(wxWindow* parent, int x, int y, const wxMouseEvent& event)

This function is simple event handler. Each time the user clicks mouse button over a cell within wxHtmlWindow this method of that cell is called. Default behavior is that it calls wxHtmlWindow::LoadPage.

Note

If you need more "advanced" event handling you should use wxHtmlBinderCell instead.

Parameters

parent

parent window (always wxHtmlWindow!)

x, y

coordinates of mouse click (this is relative to cell's origin

left, middle, right

boolean flags for mouse buttons. TRUE if the left/middle/right button is pressed, FALSE otherwise

### wxHtmlCell::SetId

void SetId(const wxString& id)

Sets unique cell identifier. Default value is no identifier, i.e. empty string.

### wxHtmlCell::SetLink

void SetLink(const wxHtmlLinkInfo& link)

Sets the hypertext link associated with this cell. (Default value is wxHtmlLinkInfo("", "") (no link))

### wxHtmlCell::SetNext

void SetNext(wxHtmlCell *cell)

Sets the next cell in the list. This shouldn't be called by user - it is to be used only by wxHtmlContainerCell::InsertCell.

### wxHtmlCell::SetParent

void SetParent(wxHtmlContainerCell *p)

Sets parent container of this cell. This is called from wxHtmlContainerCell::InsertCell.

### wxHtmlCell::SetPos

void SetPos(int x, int y)

Sets the cell's position within parent container.